%define name megaraid_sas
%define version 06.809.18.00
%define release 1
Summary: LSI Megaraid drivers for SAS 2.0
Name: %{name}
Version: %{version}
Release: %{release}
Vendor: LSI Corporation
License: GPL
Group: System Environment/Kernel
Source0: %{name}-%{version}.tar.gz
Source1: Module.supported
URL: http://www.lsi.com
Distribution: LSI Coporation
BuildRoot: /var/tmp/%{name}-buildroot
Packager: Immy Reuben <areuben@lsi.com>

%description
Drivers for (i686, x86_64, ia64, ppc64 and updates) for the
LSI Corporation Megaraid_sas  Architecture 

# prep #########################################################################
%prep
echo prep %{version}
%setup -c -b 0
cp %_sourcedir/Module.supported drivers/scsi/megaraid_sas/Module.supported


# build ########################################################################
%build
echo build %{version}
for kernel in `ls -1 /lib/modules/ | grep "^3.16"`; do
	make build  KERNEL=$kernel;
done;

# install ######################################################################
%install
echo install %{version}
echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{name}
for kernel in `ls -1 /lib/modules/ | grep "^3.16"`; do
	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid_sas
	mkdir -p $RPM_BUILD_ROOT/lib/modules/${kernel}/weak-updates/megaraid_sas

	# create the file list used in %files to indicate which files are in package
	echo "$MEGARAIDLINUX_IPATH/megaraid_sas.ko.new" >> $RPM_BUILD_DIR/file.list.%{name}

	make install PREFIX=$RPM_BUILD_ROOT KERNEL=$kernel
	mv -f $RPM_BUILD_ROOT/$MEGARAIDLINUX_IPATH/megaraid_sas.ko \
		$RPM_BUILD_ROOT/$MEGARAIDLINUX_IPATH/megaraid_sas.ko.new
done;


# pre #########################################################################
%pre
echo pre %{version}
system_arch=`uname -m`
#if [ -f /etc/SuSE-release ] && [ ${system_arch} == i686 ]; then
#	system_arch=i586;
#fi;
if [ %{_target_cpu} != ${system_arch} ]; then
	echo "ERROR: Failed installing this rpm!!!!"
	echo "This rpm is intended for %{_target_cpu} platform. It seems your system is ${system_arch}.";
	exit 1;
fi;

# post #########################################################################
%post
echo post %{version}


for kernel in `ls -1 /lib/modules`; do

	if [ ! -e /boot/vmlinuz-${kernel} ] && [ ! -e /boot/vmlinux-${kernel} ]; then
		continue;
	fi;
	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid_sas
	if [ ! -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko.new ]; then
		continue;
	fi;

	MEGARAIDLINUX_ORIG_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
	echo "The megaraid driver for kernel ${kernel} is now version 06.809.18.00";
	cp -f $MEGARAIDLINUX_IPATH/megaraid_sas.ko.new $MEGARAIDLINUX_IPATH/megaraid_sas.ko

	# Remake the initrd image
	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
	if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko \
			$MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/updates
	if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko \
			$MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/extra/megaraid_sas
	if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko \
			$MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	bootpart=/boot;
	depmod -v ${kernel} > /dev/null 2>&1;

#   By default mkinitramfs command includes only those modules present in kernel/driver/ path
#   in to the initrd image. So inorder to include megaraid_sas.ko module which is present in weak-update
#   directory in to initrd image then append "megaraid_sas" line to /etc/initramfs-tools/modules.   
#   /etc/initramfs-tools/modules stores those modules that we want to include in our initramfs.
        
        mkinitramfs_modules=/etc/initramfs-tools/modules
        pattern=`grep -R "megaraid_sas" ${mkinitramfs_modules}`
        if [ $? -ne 0 ]; then
                echo "megaraid_sas" >> ${mkinitramfs_modules} 
        else
                sed -e s/"$pattern"/megaraid_sas/ ${mkinitramfs_modules} > /tmp/mkinitramfs_modules
                mv /tmp/mkinitramfs_modules ${mkinitramfs_modules}
        fi;

	mkinitramfs -k -o ${bootpart}/initrd.img-${kernel} ${kernel}
done;
echo -e "post Install Done."

# postun #######################################################################
%postun
echo postun %{version}
for kernel in `ls -1 /lib/modules`; do

#	if [ -f /etc/redhat-release ]; then
#		if [ ! -e /boot/vmlinuz-${kernel} ]; then
#			continue;
#		fi;
#	elif [ -f /etc/SuSE-release ]; then
#		if [ `uname -m` == ppc64 ]; then
#			if [ ! -e /boot/vmlinux-${kernel} ]; then
#				continue;
#			fi;
#		else
#			if [ ! -e /boot/vmlinuz-${kernel} ]; then
#				continue;
#			fi;
#		fi;
#	fi;

	# restore original initrd images

	MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid_sas
	if [ ! -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko.new ] && \
	    [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko ]; then

		rm -rf $MEGARAIDLINUX_IPATH;

		MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
		if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig \
				$MEGARAIDLINUX_IPATH/megaraid_sas.ko
		fi;

		MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/updates
		if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig \
				$MEGARAIDLINUX_IPATH/megaraid_sas.ko
		fi;

		MEGARAIDLINUX_IPATH=/lib/modules/${kernel}/extra/megaraid_sas
		if [ -e $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MEGARAIDLINUX_IPATH/megaraid_sas.ko.orig \
				$MEGARAIDLINUX_IPATH/megaraid_sas.ko
		fi;
	fi;

	bootpart=/boot;

	if [ ! -f /lib/modules/${kernel}/kernel/drivers/scsi/megaraid/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/udpates/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/weak-updates/megaraid_sas/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/extra/megaraid_sas/megaraid_sas.ko ]; then
		sed -e '/megaraid_sas/d' /etc/modprobe.conf > modprobe.edit;
		mv -f modprobe.edit /etc/modprobe.conf;
	fi;

	depmod -v ${kernel} > /dev/null 2>&1;

#  Delete the "megaraid_sas" line from /etc/initramfs-tools/modules file
        mkinitramfs_modules=/etc/initramfs-tools/modules
        sed '/megaraid_sas/d' ${mkinitramfs_modules} > /tmp/module_remove
        mv /tmp/module_remove ${mkinitramfs_modules}

	mkinitramfs -k -o ${bootpart}/initrd.img-${kernel} ${kernel}
done;
echo -e "Uninstall Done."

# files ########################################################################
%files -f ../file.list.%{name}

# changelog  ###################################################################
%changelog
