%define kmod_name megaraid_sas
%define version 06.809.18.00
%define release 1
Summary: 	%{kmod_name} kernel module
Name: 		%{kmod_name}-kmod
Version: 	%{version}
Release: 	%{release}.fc20
Vendor: 	LSI Corporation
License: 	GPL
Group: 		System Environment/Kernel
Source0: 	lsi-%{kmod_name}-%{version}.tar.gz
Source10: 	kmodtool_%{kmod_name}
URL: 		http://www.lsilogic.com
Distribution: 	LSI Logic
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Packager: 	Sreekanth Reddy <Sreekanth.Reddy@lsi.com>

%define kmod_rel fedora18
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 3.11.10-301.fc20}

%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%ifarch i686
%define is_pae %(test -e %{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}+PAE && echo 1 || echo 0)
%if %is_pae 
%define paevar PAE
%endif
%define is_default %(test -e %{_usrsrc}/kernels/%{kverrel}.%{_target_cpu} && echo 1 || echo 0)
%if %is_default
%define upvar ""
%endif
%endif
%ifarch x86_64
%define upvar ""
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?paevar}}

ExclusiveArch:  i686 x86_64

%description
%{kmod_name} - LSI MPT Fusion HBA drivers

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:++$kvariant}
    if [ ! -e ${ksrc} ]; then
        continue;
    fi;
    cp -a lsi-%{kmod_name}-%{version} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:++$kvariant}
    if [ ! -e ${ksrc} ]; then
	continue;
    fi;
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules M=$PWD
    popd
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:++$kvariant}
    if [ ! -e ${ksrc} ]; then
	continue;
    fi;
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules_install M=$PWD
    popd
done
# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;

mkdir -p ${RPM_BUILD_ROOT}/etc/depmod.d
cat<<EOF > ${RPM_BUILD_ROOT}/etc/depmod.d/%{kmod_name}.conf
override %{kmod_name} %{kverrel}* extra/%{kmod_name}
EOF

mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/lib/firmware

%clean
rm -rf $RPM_BUILD_ROOT
