%define name megaraid_sas
%define version 06.809.18.00
%define release 1
%define Kernel 3.2.0-4
Summary: LSI MegaRAID driver
Name: %{name}
Version: %{version}
Release: %{release}
Vendor: LSI Corporation
License: GPL
Group: System Environment/Kernel
Source0: %{name}-%{version}.tar.gz
Source1: Module.supported
URL: http://www.lsi.com
Distribution: LSI Coporation
BuildRoot: /var/tmp/%{name}-buildroot
Packager: Adam Radford <Adam.Radford@lsi.com>

%description
Drivers for LSI Corporation (i686, x86_64 and updates)
MegaRAID Architecture parts.

# prep #########################################################################
%prep
echo prep %{version}
%setup -c -b 0
cp %_sourcedir/Module.supported drivers/scsi/megaraid_sas/Module.supported


# build ########################################################################
%build
echo build %{version}
if [ %{Kernel} = "generic" ]; then
	for kernel in `ls /lib/modules/`; do
		make build KERNEL=${kernel};
	done;
else
	for kernel in `ls /lib/modules/ | grep "%{Kernel}"`; do
	make build KERNEL=${kernel};
	done
fi

# install ######################################################################
%install
echo install %{version}
echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{name}
if [ %{Kernel} = "generic" ]; then
	kernel_rev="`uname -a | awk '{print $3}' | cut -d . -f 1-2`"
	for kernel in `ls /lib/modules/ | egrep '^2.6|^3.0' `; do
		MPTLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid
		mkdir -p $RPM_BUILD_ROOT/lib/modules/${kernel}/weak-updates/megaraid

		# create the file list used in %files to indicate which files are in package
		echo "$MPTLINUX_IPATH/megaraid_sas.ko" >> $RPM_BUILD_DIR/file.list.%{name}
		echo "install is called";
		make install PREFIX=$RPM_BUILD_ROOT KERNEL=${kernel}
		#mv -f $RPM_BUILD_ROOT/$MPTLINUX_IPATH/megaraid_sas.ko \
		#$RPM_BUILD_ROOT/$MPTLINUX_IPATH/megaraid_sas.ko.new
	done;
else
	for kernel in `ls /lib/modules/ | grep "%{Kernel}"`; do
		MPTLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid
		mkdir -p $RPM_BUILD_ROOT/lib/modules/${kernel}/weak-updates/megaraid

		# create the file list used in %files to indicate which files are in package
		echo "$MPTLINUX_IPATH/megaraid_sas.ko" >> $RPM_BUILD_DIR/file.list.%{name}
		echo "install is called";
		make install PREFIX=$RPM_BUILD_ROOT KERNEL=${kernel}
		#mv -f $RPM_BUILD_ROOT/$MPTLINUX_IPATH/megaraid_sas.ko \
		#$RPM_BUILD_ROOT/$MPTLINUX_IPATH/megaraid_sas.ko.new
	done
fi
# pre #########################################################################
%pre
echo pre %{version}
system_arch=`uname -m`
if [ %{_target_cpu} != ${system_arch} ]; then
	echo "ERROR: Failed installing this rpm!!!!"
	echo "This rpm is intended for %{_target_cpu} platform. It seems your system is ${system_arch}.";
	exit 1;
fi;

# post #########################################################################
%post
echo post %{version}

#blacklist_file="/etc/modprobe.d/blacklist"
for kernel in `ls /lib/modules`; do

	if [ ! -e /boot/vmlinuz-${kernel} ]; then
		continue;
	fi;
	MPTLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid
	if [ ! -e $MPTLINUX_IPATH/megaraid_sas.ko ]; then
		continue;
	fi;

	MPTLINUX_ORIG_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
	echo "The MegaRaid driver for kernel ${kernel} is now version 06.809.18.00";

	# Remake the initrd image
	MPTLINUX_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
	if [ -e $MPTLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MPTLINUX_IPATH/megaraid_sas.ko \
			$MPTLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	MPTLINUX_IPATH=/lib/modules/${kernel}/updates
	if [ -e $MPTLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MPTLINUX_IPATH/megaraid_sas.ko \
			$MPTLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	MPTLINUX_IPATH=/lib/modules/${kernel}/extra/megaraid
	if [ -e $MPTLINUX_IPATH/megaraid_sas.ko ]; then
		mv $MPTLINUX_IPATH/megaraid_sas.ko \
			$MPTLINUX_IPATH/megaraid_sas.ko.orig
	fi;

	bootpart=/boot;
	depmod -v ${kernel} > /dev/null 2>&1;

	mkinitramfs_modules=/etc/initramfs-tools/modules
	pattern=`grep -R "megaraid_sas" ${mkinitramfs_modules}`
	if [ $? -ne 0 ]; then
		echo "megaraid_sas" >> ${mkinitramfs_modules} 
	else
		sed -e s/"$pattern"/megaraid_sas/ ${mkinitramfs_modules} > /tmp/mkinitramfs_modules
		mv /tmp/mkinitramfs_modules ${mkinitramfs_modules}
	fi;

	mkinitramfs -k -o ${bootpart}/initrd.img-${kernel} ${kernel}
	sed -e '/megaraid_sas/d' /etc/modules > modules.edit;
	mv -f modules.edit /etc/modules;
	echo megaraid_sas >> /etc/modules
done;
echo -e "post Install Done."

# postun #######################################################################
%postun
echo postun %{version}
for kernel in `ls -1 /lib/modules`; do
	MPTLINUX_IPATH=/lib/modules/${kernel}/weak-updates/megaraid

	if [ ! -e $MPTLINUX_IPATH/megaraid_sas.ko ]; then

		rm -rf $MPTLINUX_IPATH;

		MPTLINUX_IPATH=/lib/modules/${kernel}/kernel/drivers/scsi/megaraid
		if [ -e $MPTLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MPTLINUX_IPATH/megaraid_sas.ko.orig \
				$MPTLINUX_IPATH/megaraid_sas.ko
		fi;

		MPTLINUX_IPATH=/lib/modules/${kernel}/updates
		if [ -e $MPTLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MPTLINUX_IPATH/megaraid_sas.ko.orig \
				$MPTLINUX_IPATH/megaraid_sas.ko
		fi;

		MPTLINUX_IPATH=/lib/modules/${kernel}/extra/megaraid
		if [ -e $MPTLINUX_IPATH/megaraid_sas.ko.orig ]; then
			mv $MPTLINUX_IPATH/megaraid_sas.ko.orig \
				$MPTLINUX_IPATH/megaraid_sas.ko
		fi;
	fi;

	bootpart=/boot;
	if [ ! -f /lib/modules/${kernel}/kernel/drivers/scsi/megaraid/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/updates/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/weak-updates/megaraid/megaraid_sas.ko ] && \
	   [ ! -f /lib/modules/${kernel}/extra/megaraid/megaraid_sas.ko ]; then
		sed -e '/megaraid_sas/d' /etc/modprobe.conf > modprobe.edit;
		mv -f modprobe.edit /etc/modprobe.conf;
	fi;

	depmod -v ${kernel} > /dev/null 2>&1;

        mkinitramfs_modules=/etc/initramfs-tools/modules
	sed '/megaraid_sas/d' ${mkinitramfs_modules} > /tmp/module_remove
	mv /tmp/module_remove ${mkinitramfs_modules}

	mkinitramfs -k -o ${bootpart}/initrd.img-${kernel} ${kernel}
	sed -e '/megaraid_sas/d' /etc/modules > modules.edit;
	mv -f modules.edit /etc/modules;
	echo megaraid_sas >> /etc/modules
done;
echo -e "Uninstall Done."

# files ########################################################################
%files -f ../file.list.%{name}
